Index: src/UIElements/TextUI/Query/AtomTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/AtomTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/AtomTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -24,5 +24,5 @@
 #include <Descriptors/AtomDescriptor.hpp>
 #include <Descriptors/AtomIdDescriptor.hpp>
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/AtomsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/AtomsTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/AtomsTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <Descriptors/AtomDescriptor.hpp>
 #include <Descriptors/AtomIdDescriptor.hpp>
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/BooleanTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/BooleanTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/BooleanTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/BoxTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/BoxTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/BoxTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/DoubleTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/DoubleTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/DoubleTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/DoublesTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/DoublesTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/DoublesTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/ElementTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/ElementTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/ElementTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/ElementsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/ElementsTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/ElementsTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -23,5 +23,5 @@
 #include <boost/lexical_cast.hpp>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/EmptyTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/EmptyTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/EmptyTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/FileTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/FileTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/FileTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -24,5 +24,5 @@
 #include <boost/filesystem.hpp>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/IntTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/IntTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/IntTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/IntsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/IntsTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/IntsTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/MoleculeTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/MoleculeTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/MoleculeTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -24,5 +24,5 @@
 #include <Descriptors/MoleculeDescriptor.hpp>
 #include <Descriptors/MoleculeIdDescriptor.hpp>
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/MoleculesTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/MoleculesTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/MoleculesTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -24,5 +24,5 @@
 #include <Descriptors/MoleculeDescriptor.hpp>
 #include <Descriptors/MoleculeIdDescriptor.hpp>
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/StringTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/StringTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/StringTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/StringsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/StringsTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/StringsTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/TextQuery.hpp
===================================================================
--- src/UIElements/TextUI/Query/TextQuery.hpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
+++ src/UIElements/TextUI/Query/TextQuery.hpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -0,0 +1,139 @@
+/*
+ * TextQuery.hpp
+ *
+ *  Created on: Nov 8, 2010
+ *      Author: heber
+ */
+
+#ifndef TEXTQUERY_HPP_
+#define TEXTQUERY_HPP_
+
+#include "TextUI/TextDialog.hpp"
+
+class TextDialog::AtomTextQuery : public Dialog::AtomQuery {
+public:
+  AtomTextQuery(std::string title, std::string _description = NULL);
+  virtual ~AtomTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::AtomsTextQuery : public Dialog::AtomsQuery {
+public:
+  AtomsTextQuery(std::string title, std::string _description = NULL);
+  virtual ~AtomsTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::BooleanTextQuery : public Dialog::BooleanQuery {
+public:
+  BooleanTextQuery(std::string title, std::string _description = NULL);
+  virtual ~BooleanTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::BoxTextQuery : public Dialog::BoxQuery {
+public:
+  BoxTextQuery(std::string title, std::string _description = NULL);
+  virtual ~BoxTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::DoubleTextQuery : public Dialog::DoubleQuery {
+public:
+  DoubleTextQuery(std::string title, std::string _description = NULL);
+  virtual ~DoubleTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::DoublesTextQuery : public Dialog::DoublesQuery {
+public:
+  DoublesTextQuery(std::string title, std::string _description = NULL);
+  virtual ~DoublesTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::ElementTextQuery : public Dialog::ElementQuery {
+public:
+  ElementTextQuery(std::string title, std::string _description = NULL);
+  virtual ~ElementTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::ElementsTextQuery : public Dialog::ElementsQuery {
+public:
+  ElementsTextQuery(std::string title, std::string _description = NULL);
+  virtual ~ElementsTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::EmptyTextQuery : public Dialog::EmptyQuery {
+public:
+  EmptyTextQuery(std::string title, std::string _description = NULL);
+  virtual ~EmptyTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::FileTextQuery : public Dialog::FileQuery {
+public:
+  FileTextQuery(std::string title, std::string _description = NULL);
+  virtual ~FileTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::IntTextQuery : public Dialog::IntQuery {
+public:
+  IntTextQuery(std::string title, std::string _description = NULL);
+  virtual ~IntTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::IntsTextQuery : public Dialog::IntsQuery {
+public:
+  IntsTextQuery(std::string title, std::string _description = NULL);
+  virtual ~IntsTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::MoleculeTextQuery : public Dialog::MoleculeQuery {
+public:
+  MoleculeTextQuery(std::string title, std::string _description = NULL);
+  virtual ~MoleculeTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::MoleculesTextQuery : public Dialog::MoleculesQuery {
+public:
+  MoleculesTextQuery(std::string title, std::string _description = NULL);
+  virtual ~MoleculesTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::StringTextQuery : public Dialog::StringQuery {
+public:
+  StringTextQuery(std::string title, std::string _description = NULL);
+  virtual ~StringTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::StringsTextQuery : public Dialog::StringsQuery {
+public:
+  StringsTextQuery(std::string title, std::string _description = NULL);
+  virtual ~StringsTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::VectorTextQuery : public Dialog::VectorQuery {
+public:
+  VectorTextQuery(std::string title,bool _check, std::string _description = NULL);
+  virtual ~VectorTextQuery();
+  virtual bool handle();
+};
+
+class TextDialog::VectorsTextQuery : public Dialog::VectorsQuery {
+public:
+  VectorsTextQuery(std::string title,bool _check, std::string _description = NULL);
+  virtual ~VectorsTextQuery();
+  virtual bool handle();
+};
+
+#endif /* TEXTQUERY_HPP_ */
Index: src/UIElements/TextUI/Query/VectorTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/VectorTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/VectorTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"
Index: src/UIElements/TextUI/Query/VectorsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/VectorsTextQuery.cpp	(revision 8df74dbef13fb1628a8f98eeaac6b7c477e95818)
+++ src/UIElements/TextUI/Query/VectorsTextQuery.cpp	(revision 308aa43f3e30fb9a88d9923d90ff3940289ce5a3)
@@ -22,5 +22,5 @@
 #include <iostream>
 
-#include "TextUI/TextDialog.hpp"
+#include "TextUI/Query/TextQuery.hpp"
 
 #include "Helpers/Log.hpp"