Index: src/Actions/FragmentationAction/MolecularDynamicsAction.cpp
===================================================================
--- src/Actions/FragmentationAction/MolecularDynamicsAction.cpp	(revision 95cfacdff536aaf7fb3937c5b0656feb10da531c)
+++ src/Actions/FragmentationAction/MolecularDynamicsAction.cpp	(revision 329cf3be784f771a68fd139004a418721050fa4c)
@@ -54,5 +54,5 @@
 
 // static instances
-ActionSequence FragmentationMolecularDynamicsAction::actions;
+ActionSequence FragmentationMolecularDynamicsAction::prototype_actions;
 bool FragmentationMolecularDynamicsAction::isPrepared = false;
 
@@ -62,13 +62,13 @@
   // present. If not, we still copy the position cleanly into a new step where then
   // forces are set according to summed fragmentary contributions. This is much cleaner.
-  actions.addAction(AR.getActionByName(std::string("verlet-integration")));
-  actions.addAction(AR.getActionByName(std::string("output")));
-  actions.addAction(AR.getActionByName(std::string("clear-fragment-results")));
-  actions.addAction(AR.getActionByName(std::string("destroy-adjacency")));
-  actions.addAction(AR.getActionByName(std::string("create-adjacency")));
-  actions.addAction(AR.getActionByName(std::string("update-molecules")));
-  actions.addAction(AR.getActionByName(std::string("fragment-molecule")));
-  actions.addAction(AR.getActionByName(std::string("fragment-automation")));
-  actions.addAction(AR.getActionByName(std::string("analyse-fragment-results")));
+  prototype_actions.addAction(AR.getActionByName(std::string("verlet-integration")));
+  prototype_actions.addAction(AR.getActionByName(std::string("output")));
+  prototype_actions.addAction(AR.getActionByName(std::string("clear-fragment-results")));
+  prototype_actions.addAction(AR.getActionByName(std::string("destroy-adjacency")));
+  prototype_actions.addAction(AR.getActionByName(std::string("create-adjacency")));
+  prototype_actions.addAction(AR.getActionByName(std::string("update-molecules")));
+  prototype_actions.addAction(AR.getActionByName(std::string("fragment-molecule")));
+  prototype_actions.addAction(AR.getActionByName(std::string("fragment-automation")));
+  prototype_actions.addAction(AR.getActionByName(std::string("analyse-fragment-results")));
   isPrepared = true;
 }
@@ -77,5 +77,5 @@
 {
   // empty sequence
-  while (actions.removeLastAction() != NULL);
+  while (prototype_actions.removeLastAction() != NULL);
   isPrepared = false;
 }
Index: src/Actions/FragmentationAction/StructuralOptimizationAction.cpp
===================================================================
--- src/Actions/FragmentationAction/StructuralOptimizationAction.cpp	(revision 95cfacdff536aaf7fb3937c5b0656feb10da531c)
+++ src/Actions/FragmentationAction/StructuralOptimizationAction.cpp	(revision 329cf3be784f771a68fd139004a418721050fa4c)
@@ -54,5 +54,5 @@
 
 // static instances
-ActionSequence FragmentationStructuralOptimizationAction::actions;
+ActionSequence FragmentationStructuralOptimizationAction::prototype_actions;
 bool FragmentationStructuralOptimizationAction::isPrepared = false;
 
@@ -62,13 +62,13 @@
   // present. If not, we still copy the position cleanly into a new step where then
   // forces are set according to summed fragmentary contributions. This is much cleaner.
-  actions.addAction(AR.getActionByName(std::string("destroy-adjacency")));
-  actions.addAction(AR.getActionByName(std::string("create-adjacency")));
-  actions.addAction(AR.getActionByName(std::string("update-molecules")));
-  actions.addAction(AR.getActionByName(std::string("fragment-molecule")));
-  actions.addAction(AR.getActionByName(std::string("fragment-automation")));
-  actions.addAction(AR.getActionByName(std::string("analyse-fragment-results")));
-  actions.addAction(AR.getActionByName(std::string("force-annealing")));
-  actions.addAction(AR.getActionByName(std::string("output")));
-  actions.addAction(AR.getActionByName(std::string("clear-fragment-results")));
+  prototype_actions.addAction(AR.getActionByName(std::string("destroy-adjacency")));
+  prototype_actions.addAction(AR.getActionByName(std::string("create-adjacency")));
+  prototype_actions.addAction(AR.getActionByName(std::string("update-molecules")));
+  prototype_actions.addAction(AR.getActionByName(std::string("fragment-molecule")));
+  prototype_actions.addAction(AR.getActionByName(std::string("fragment-automation")));
+  prototype_actions.addAction(AR.getActionByName(std::string("analyse-fragment-results")));
+  prototype_actions.addAction(AR.getActionByName(std::string("force-annealing")));
+  prototype_actions.addAction(AR.getActionByName(std::string("output")));
+  prototype_actions.addAction(AR.getActionByName(std::string("clear-fragment-results")));
   isPrepared = true;
 }
@@ -77,5 +77,5 @@
 {
   // empty sequence
-  while (actions.removeLastAction() != NULL);
+  while (prototype_actions.removeLastAction() != NULL);
   isPrepared = false;
 }